-- == TODO: add temporary pets, totems, lightwell, traps? cc? duration as a countdown
local overlays = {}
local spinners = {}
local auras = {}

local SharedAuras = {
	-- This is not a comprehensive list
	--_.:: Buffs ::._--
	
	[79107] = '+shadowres', -- Shadow Protection (Priest)
	-->> +% Stats
	[79062] = '+stats', -- Blessing of Kings (Paladin) aura
	[79063] = '+stats', -- Blessing of Kings (Paladin) aura
	[20217] = '+stats', -- Blessing of Kings (Paladin) ability
	[90363] = '+stats', -- Embrace of the Shale Spider (Hunter: Shale Spider)
	[79060] = '+stats', -- Mark of the Wild (Druid) aura (i don't know what the difference is)
	[79061] = '+stats', -- Mark of the Wild (Druid) aura
	[1126] = '+stats', -- Mark of the Wild (Druid) ability
	-->> + Agi/Str
	[6673] = '+agistr', -- Battle Shout (Warrior)
	[57330] = '+agistr', -- Horn of Winter (Death Knight)
	[93435] = '+agistr', -- Roar of Courage (Hunter: Cat, Spirit Beast)
	[8076] = '+agistr', -- Strength of Earth (Shaman)
	-->> + Stamina
	[6307] = '+stam', -- Blood Pact (Warlock: Imp)
	[469] = '+stam', -- Commanding Shout (Warrior)
	[21562] = '+stam', -- Power Word: Fortitude (Priest)
	[79105] = '+stam', -- Power Word: Fortitude (Priest)
	[90364] = '+stam', -- Qiraji Fortitude (Hunter: Silithid)
	-->> + Max Mana
	[1459] = 1459, -- Arcane Brilliance (Mage) ability
	[79057] = 1459, -- Arcane Brilliance (Mage) buff
	[61316] = 1459, -- Dalaran Brilliance (Mage) buff
	--[54424] = '+maxmana', -- Fel Intelligence (Warlock: Felhunter)

	-->> +3% Damage (I think these are passive anyway)
	[75447] = '+alldmg', -- Ferocious Inspiration (Hunter)
	[82930] = '+alldmg', -- Arcane Tactics (Mage)
	--[465] = '+alldmg', -- Devotion Aura (Paladin w/ Communion)
	--[7294] = '+alldmg', -- Retribution Aura (Paladin w/ Communion)
	--[19746] = '+alldmg', -- Concentration Aura (Paladin w/ Communion)
	--[19891] = '+alldmg', -- Resistance Aura (Paladin w/ Communion)
	--[32223] = '+alldmg', -- Crusader Aura (Paladin w/ Communion)
	-->> +5% Crit
	[51470] = '+crit', -- Elemental Oath (Shaman)
	[24604] = '+crit', -- Furious Howl (Hunter: Wolf)
	[51698] = '+crit', -- Honor Among Thieves (Rogue)
	[24932] = '+crit', -- Leader of the Pack (Druid)
	[29801] = '+crit', -- Rampage (Warrior)
	[90309] = '+crit', -- Terrifying Roar (Hunter: Devilsaur)
	-->> +30% haste
	[90355] = 'lust', -- Ancient Hysteria (Hunter: Corehound)
	[2825] = 'lust', -- Bloodlust (Shaman)
	[32182] = 'lust', -- Heroism (Shaman)
	[80353] = 'lust', -- Time Warp (Mage)

	-->> +% Attack Power
	[53137] = '+atkpwr', -- Abomination's Might (Death Knight)
	[79102] = '+atkpwr', -- Blessing of Might (Paladin)
	[19506] = '+atkpwr', -- Trueshot Aura (Hunter)
	[30802] = '+atkpwr', -- Unleashed Rage (Shaman)
	-->> + Physical Haste
	[53290] = '+atkspd', -- Hunting Party (Hunter)
	[55610] = '+atkspd', -- Improved Icy Talons (Death Knight)
	[8515] = '+atkspd', -- Windfury Totem (Shaman)

	-->> +6% Spell Power
	--[79057] = '+6spellpwr,+int', -- Arcane Brilliance (Mage)
	--[52109] = '+6spellpwr', -- Flametongue Totem (Shaman)
	
	-->> +10% Spell Power
	[47236] = '+10spellpwr', -- Demonic Pact (Warlock)
	[77747] = '+10spellpwr', -- Totemic Wrath (Shaman)
	
	-->> + Spell Haste
	[24907] = '+castspd', -- Moonkin Aura (Druid)
	[49868] = '+castspd', -- Mind Quickening (Priest Shadowform)
	[2895] = '+castspd', -- Wrath of Air Totem (Shaman)
	
	-->> - Spell Pushback
	[19746] = '-pushback', -- Concentration Aura (Paladin)
	[87717] = '-pushback', -- Tranquil Mind (Shaman)
	
	-->> + Mana Regen
	[79102] = 79102, -- Blessing of Might (Paladin)
	--[54424] = '+manaregen', -- Fel Intelligence (Warlock: Felhunter)
	--[5677] = '+manaregen', -- Mana Spring (Shaman)

    -->> + Armor
	[465] = '+armor', -- Devotion Aura (Paladin)
	[8072] = '+armor', -- Stoneskin (Shaman)

	-->> Speed
    [68992] = '+speed', -- Darkflight (Worgen racial)
    [1850] = '+speed', -- Dash (Druid)
    [77764] = '+speed', -- Stampeding Roar (Druid Cat)
    [77761] = '+speed', -- Stampeeding Roar (Druid Bear)
    [13141] = '+speed', -- Gnomish Rocket Boots (item)
    [8892] = '+speed', -- Goblin Rocket Boots (item)
    [2379] = '+speed', -- Speed (Swiftness Potion item)
    [14530] = '+speed', -- Speed (Nifty Stopwatch item)
    [2983] = '+speed', -- Sprint (Rogue)
    [64127] = '+speed', -- Body and Soul? rank 1 (Priest)
    [64129] = '+speed', -- Body and Soul? rank 2 (Priest)

	
	--_.:: Debuffs ::._--
	
	-->> Abilities that just don't stack
	--[31589] = 31589, -- Slow (Mage)
	[1130] = 1130, -- Hunter's Mark (Hunter)
	
	-->> Consolidate crowd controls?
	--[ Druid ]
	[2637] = 'CC', -- Hibernate
	--[339] = 'CC', -- Entangling Roots
	--[ Hunter ]
	[3355] = 'CC', -- Freezing Trap Debuff
	[1499] = 'CC', -- Freezing Trap Ability
	[60192] = 'CC',  -- Freezing Trap Launcher Ability
	[1513] = 'CC', -- Scare Beast
	[19386] = 'CC', -- Wyvern Sting
	--[ Warlock ]
	[5782] = 'CC', -- Fear
	[710] = 'CC',  -- Banish
	[6358] = 'CC', -- Seduction
	--[ Mage ]
	[118] = 'CC', -- Polymorph (Sheep)
	[61305] = 'CC', -- Polymorph (Black Cat)
	[28272] = 'CC', -- Polymorph (Pig)
	[61721] = 'CC', -- Polymorph (Rabbit)
	[61780] = 'CC', -- Polymorph (Turkey)
	[28271] = 'CC', -- Polymorph (Turtle)
	--[ Paladin ]
	[20066] = 'CC', -- Repentance
	[10326] = 'CC', -- Turn Evil
	--[ Rogue ]
	[6770] = 'CC', -- Sap
	[2094] = 'CC', -- Blind
	--[ Shaman ]
	[51514] = 'CC',  -- Hex
	[76780] = 'CC', -- Bind Elemental
	--[ Priest ]
	[9484] = 'CC',   -- Shackle Undead

	-->> -% Damage
	[702] = '-outdmg', -- Curse of Weakness (Warlock)
	[99] = '-outdmg', -- Demoralizing Roar (Druid)
	[50256] = '-outdmg', -- Demoralizing Roar (Hunter: Bear)
	[1160] = '-outdmg', -- Demoralizing Shout (Warrior)
	[81130] = '-outdmg', -- Scarlet Fever (Death Knight)
	[26017] = '-outdmg', -- Vindication (Paladin)

	-->> -20% Attack Speed
    [54404] = '-atkspd', -- Dust Cloud (Hunter: Tallstrider)
    [8042] = '-atkspd', -- Earth Shock (Shaman)
    [55095] = '-atkspd', -- Frost Fever (Death Knight)
    [58180] = '-atkspd', -- Infected Wounds (Druid)
    [68055] = '-atkspd', -- Judgements of the Just (Paladin)
    [14251] = '-atkspd', -- Riposte (Rogue)
    [90315] = '-atkspd', -- Tailspin (Hunter: Fox)
    [6343] = '-atkspd', -- Thunder Clap (Warrior)

	-->> -30% Cast Speed
    [1714] = '-castspd', -- Curse of Tongues (Warlock)
    [58604] = '-castspd', -- Lava Breath (Hunter: Corehound)
    [5760] = '-castspd', -- Mind-numbing Poison (Rogue)
    [73975] = '-castspd', -- Necrotic Strike (Death Knight)
    --[31589] = '-castspd', -- Slow (Mage)
    [50274] = '-castspd', -- Spore Cloud (Hunter: Sporebat)

	-->> -12% Armor
	[770] = "-armor", -- faerie fire (druid)
	[16857] = "-armor", -- feral faerie fire (druid)
	[8647] = "-armor", -- expose armor (rogue)
	[7386] = "-armor", -- sunder armor (warrior) (ability?)
	[58567] = "-armor", -- sunder armor (warrior) (triggered?)
	[20243] = "-armor", -- devastate (warrior) (i think this just triggers sunder armor?)
	[50498] = "-armor", -- tear armor (raptor/hunter) (might just be the ability)
	[95467] = "-armor", -- tear armor (raptor/hunter) (i think this is the actual debuff)
	[35387] = "-armor", -- corrosive spit (serpent/hunter) (ability)
	[95466] = "-armor", -- corrosive spit (serpent/hunter) (triggered?)
	
	-->> +% Physical Damage Taken
    [55749] = '+indmg', -- Acid Spit (Hunter: Worm)
    [30069] = '+indmg', -- Blood Frenzy (Warrior)
    [81326] = '+indmg', -- Brittle Bones (Death Knight)
    [50518] = '+indmg', -- Ravage (Hunter: Ravager)
    [58684] = '+indmg', -- Savage Combat (Rogue)

	-->> +% Bleed Damage Taken
    [35290] = '+bleed', -- Gore (Hunter: Boar)
    [16511] = '+bleed', -- Hemorrhage (Rogue)
    [33878] = '+bleed', -- Mangle (Bear) (Druid)
    [33876] = '+bleed', -- Mangle (Cat) (Druid)
    [57386] = '+bleed', -- Stampede (Hunter: Rhino)
    [50271] = '+bleed', -- Tendon Rip (Hyena)
    [46857] = '+bleed', -- Trauma (Warrior)

	-->> +% Spell Damage Taken
	[1490] = '+inspelldmg', -- Curse of the Elements (Warlock)
	[60433] = '+inspelldmg', -- Earth and Moon (Druid)
	[65142] = '+inspelldmg', -- Ebon Plague (Death Knight)
	[34889] = '+inspelldmg', -- Fire Breath (Hunter: Dragonhawk)
	[85547] = '+inspelldmg', -- Jinx: Curse of the Elements (Warlock)
	[24844] = '+inspelldmg', -- Lightning Breath (Hunter: Wind Serpent)
	[93068] = '+inspelldmg', -- Master Poisoner (Rogue)
	
	-->> + Spell Crit Taken
	[11095] = '+inspellcrit', -- Critical Mass (Mage)
	[30288] = '+inspellcrit', -- Shadow and Flame (Warlock)
	
	-->> -% Healing Taken
	[56112] = '-heal', -- Furious Attacks (Warrior)
	[30213] = '-heal', -- Legion Strike (Warlock: Felguard)
	[48301] = '-heal', -- Mind Trauma (Priest)
	[54680] = '-heal', -- Monstrous Bite (Hunter: Devilsaur)
	[12294] = '-heal', -- Mortal Strike (Warrior)
	[68391] = '-heal', -- Permafrost (Mage)
	[82654] = '-heal', -- Widow Venom (Hunter)
	[13218] = '-heal', -- Wound Poison (Rogue)

	-->> Disarm
	[50541] = 'disarmed', -- Clench (Hunter: Scorpid)
	[676] = 'disarmed', -- Disarm (Warrior)
	[51722] = 'disarmed', -- Dismantle (Rogue)
	[64058] = 'disarmed', -- Psychic Horror (Priest)
	[91644] = 'disarmed', -- Snatch (Hunter: Bird of Prey)

	-->> Silenced
	[28730] = 'silenced', -- Arcane Torrent (Mana)
	[50613] = 'silenced', -- Arcane Torrent (Runic Power)
	[80483] = 'silenced', -- Arcane Torrent (Focus)
	[25046] = 'silenced', -- Arcane Torrent (Energy)
	[69179] = 'silenced', -- Arcane Torrent (Rage)
    [31935] = 'silenced', -- Avenger's Shield (Paladin)
    [1330] = 'silenced', -- Garrote - Silence (Rogue)
    [50479] = 'silenced', -- Nether Shock (Hunter: Nether Ray)
    [15487] = 'silenced', -- Silence (Priest)
    [18498] = 'silenced', -- Silenced - Gag Order (Warrior)
    [18469] = 'silenced', -- Silenced - Improved Counterspell (Mage)
    [18425] = 'silenced', -- Silenced - Improved Kick (Rogue)
    [34490] = 'silenced', -- Silencing Shot (Hunter)
    [81261] = 'silenced', -- Solar Beam (Druid)
    [24259] = 'silenced', -- Spell Lock (Warlock: Fel Hunter)
    [47476] = 'silenced', -- Strangulate (Death Knight)

    -->> Stun
    [85387] = 'stunned', -- Aftermath (Warlock)
    [89766] = 'stunned', -- Axe Toss (Warlock: Felguard)
    [5211] = 'stunned', -- Bash (Druid)
    [93433] = 'stunned', -- Burrow Attack (Hunter: Worm)
    [7922] = 'stunned', -- Charge Stun (Warrior)
    [1833] = 'stunned', -- Cheap Shot (Rogue)
    [12809] = 'stunned', -- Concussion Blow (Warrior)
    [44572] = 'stunned', -- Deep Freeze (Mage)
    [45334] = 'stunned', -- Feral Charge (Bear) (Druid)
    [91800] = 'stunned', -- Gnaw (Death Knight: Ghoul)
    [853] = 'stunned', -- Hammer of Justice (Paladin)
    [88625] = 'stunned', -- Holy Word: Chastise (Priest)
    [2812] = 'stunned', -- Holy Wrath (Paladin)
    [12355] = 'stunned', -- Impact (Mage)
    [20253] = 'stunned', -- Intercept (Warrior)
    [19577] = 'stunned', -- Intimidation (Hunter)
    [408] = 'stunned', -- Kidney Shot (Rogue)
    [22570] = 'stunned', -- Maim (Druid)
    [9005] = 'stunned', -- Pounce (Druid)
    [82691] = 'stunned', -- Ring of Frost (Mage)
    [30283] = 'stunned', -- Shadowfury (Warlock)
    [46968] = 'stunned', -- Shockwave (Warrior)
    [50519] = 'stunned', -- Sonic Blast (Hunter: Bat)
    [56626] = 'stunned', -- Sting (Hunter: Wasp)
    [85388] = 'stunned', -- Throwdown (Warrior)
    [20549] = 'stunned', -- War Stomp (Tauren racial)
    
    -->> Root
    [19306] = 'root', -- Counterattack (Hunter)
    [64695] = 'root', -- Earthgrab (Shaman)
    [339] = 'root', -- Entangling Roots (Druid)
    [19185] = 'root', -- Entrapment (Hunter)
    [63685] = 'root', -- Freeze [Frost Shock] (Shaman)
    [33395] = 'root', -- Freeze [Water Elemental] (Mage)
    [39965] = 'root', -- Frost Grenade (item)
    [122] = 'root', -- Frost Nova (Mage)
    [55536] = 'root', -- Frostweave Net (item)
    [58373] = 'root', -- Glyph of Hamstring (Warrior)
    [23694] = 'root', -- Improved Hamstring (Warrior)
    [90327] = 'root', -- Lock Jaw (Hunter: Dog)
    [13099] = 'root', -- Net-o-Matic (Gnomish Net-o-Matic Projector item)
    [94358] = 'root', -- Overgrowth (Druid)
    [50245] = 'root', -- Pin (Hunter: Crab)
    [55080] = 'root', -- Shattered Barrier (Mage)
    [54706] = 'root', -- Venom Web Spray (Hunter: Silithid)
    [4167] = 'root', -- Web (Hunter: Spider)
    
	-->> Slow
    [18118] = 'slow', -- Aftermath (Warlock)
    [50433] = 'slow', -- Ankle Crack (Hunter: Crocolisk)
    [31126] = 'slow', -- Blade Twisting (Rogue)
    [11113] = 'slow', -- Blast Wave (Mage)
    [45524] = 'slow', -- Chains of Ice (Death Knight)
    [50434] = 'slow', -- Chilblains (Death Knight)
    [6136] = 'slow', -- Chilled (Frost Armor) (Mage)
    [7321] = 'slow', -- Chilled (Ice Armor) (Mage)
    [20005] = 'slow', -- Chilled (Icy Chill enchantment)
    [16927] = 'slow', -- Chilled (Frostguard item)
    [35101] = 'slow', -- Concussive Barrage (Hunter)
    [5116] = 'slow', -- Concussive Shot (Hunter)
    [120] = 'slow', -- Cone of Cold (Mage)
    [3409] = 'slow', -- Crippling Poison (Rogue)
    [18223] = 'slow', -- Curse of Exhaustion (Warlock)
    [1604] = 'slow', -- Dazed
    [50259] = 'slow', -- Dazed (Feral Charge Cat) (Druid)
    [26679] = 'slow', -- Deadly Throw (Rogue)
    [68766] = 'slow', -- Desecration (Death Knight)
    [3600] = 'slow', -- Earthbind (Shaman)
    [54644] = 'slow', -- Frost Breath (Hunter: Chimaera)
    [8056] = 'slow', -- Frost Shock (Shaman)
    [116] = 'slow', -- Frostbolt (Mage)
    [8034] = 'slow', -- Frostbrand Attack (Shaman)
    [44614] = 'slow', -- Frostfire Bolt (Mage)
    [61394] = 'slow', -- Frozen Wake (Glyph of Freezing Trap) (Hunter)
    [58617] = 'slow', -- Glyph of Heart Strike (Death Knight)
    [1715] = 'slow', -- Hamstring (Warrior)
    [13810] = 'slow', -- Ice Trap (Hunter)
    --[58180] = 'slow', -- Infected Wounds (Druid)
    [15407] = 'slow', -- Mind Flay (Priest)
    [12323] = 'slow', -- Piercing Howl (Warrior)
    [31589] = 'slow', -- Slow (Mage)
    [35346] = 'slow', -- Time Warp (Hunter: Warp Stalker)
    [51693] = 'slow', -- Waylay (Rogue)
    [2974] = 'slow', -- Wing Clip (Hunter)

    -->> Taunt?
    [5209] = 'taunt', -- Challenging Roar (Druid)
    [1161] = 'taunt', -- Challenging Shout (Warrior)
    [56222] = 'taunt', -- Dark Command (Death Knight)
    [57603] = 'taunt', -- Death Grip (Death Knight)
    [20736] = 'taunt', -- Distracting Shot (Hunter)
    [6795] = 'taunt', -- Growl (Druid)
    [62124] = 'taunt', -- Hand of Reckoning (Paladin)
    [31790] = 'taunt', -- Righteous Defense (Paladin)
    [17735] = 'taunt', -- Suffering (Warlock: Voidwalker)
    [355] = 'taunt', -- Taunt (Warrior)
    [53477] = 'taunt', -- Taunt (Hunter: tenacity)
    [58857] = 'taunt', -- Twin Howl (Shaman: Spirit Wolves)
}



local function formatTime( seconds )
	local tempTime;
	if ( seconds >= 86400  ) then
		tempTime = floor(seconds / 86400);
		return "%dd", tempTime;
	end
	if ( seconds >= 3600  ) then
		tempTime = floor(seconds / 3600);
		return "%dh", tempTime;
	end
	if ( seconds >= 60  ) then
		tempTime = floor(seconds / 60);
		return "%dm", tempTime;
	end
	if ( seconds >= 10  ) then
		tempTime = floor(seconds);
		return "%d", tempTime;
	end
	tempTime = floor(seconds*10)/10;
	return "%.1f", tempTime;
end

local f = CreateFrame("Frame")

local tooltip = CreateFrame("GameTooltip",  "CrackCooldownTooltip", nil, "GameTooltipTemplate")
local BLOOD = RUNE_COST_BLOOD:gsub("%%d", "(%%d+)") -- "%d Blood" -> "(%d+) Blood"
local FROST = RUNE_COST_FROST:gsub("%%d", "(%%d+)")
local UNHOLY = RUNE_COST_UNHOLY:gsub("%%d", "(%%d+)")

local function GetRuneCost(spellId)
	tooltip:SetOwner(UIParent, "ANCHOR_NONE")
	tooltip:ClearLines()
	tooltip:SetSpellByID(spellId)
	local cost = CrackCooldownTooltipTextLeft2:GetText()
	return tonumber(cost:match(BLOOD)) or 0, tonumber(cost:match(FROST)) or 0, tonumber(cost:match(UNHOLY)) or 0
end

local function GetRuneCooldownBySpell(spellId) -- Oh god, I'm so sorry.
	local b, f, u = GetRuneCost(spellId)
	local c = {b,u,f} -- the rune order in the ui is 1,2,5,6,3,4
	local now = GetTime()
	local runes = {}
	for i = 1,6 do
		local runeType = GetRuneType(i)
		if not runes[runeType] then
			runes[runeType] = {}
		end
		local start, length, ready = GetRuneCooldown(i)
		local cd = ready and 0 or start + length - now
		tinsert(runes[runeType], cd)
		table.sort(runes[runeType])
	end
	-- for each rune in cost do
	-- if death rune and blood rune then
	-- pick shorter of the two
	-- else if blood rune use shortest blood rune
	-- else if death rune use shortest death rune
	
	local results = {}
	for i,r in ipairs(c) do
		if r > 0 then
			for j=1,r do
				if runes[4] and runes[4][1] and runes[i] and runes[i][1] then -- death & whatever rune
					if runes[4][1] < runes[i][1] then
						tinsert(results, tremove(runes[4],1)) -- pop off rune table onto results
					else
						tinsert(results, tremove(runes[i],1))
					end
				elseif runes[i] and runes[i][1] then
					tinsert(results, tremove(runes[i],1))
				elseif runes[4] and runes[4][1] then
					tinsert(results, tremove(runes[4],1))
				else
					return 0
				end
			end
		end
	end
	if #results > 0 then
		return math.max(unpack(results)) or 0
	else
		return 0
	end
end

local function GetTotemCooldown(totem)
	for i=1,4 do
		local haveTotem, name, startTime, duration, icon = GetTotemInfo(i)
		if haveTotem and name == totem then
			return (startTime + duration) or 0
		end
	end
	return 0
end

local function GetSlotCooldown(slot)
	local now = GetTime()
	local cooldownStart, cooldownLength = GetActionCooldown( slot )
	local endTime = cooldownStart + cooldownLength
	local realCooldown, energyCooldown, auraDuration = 0, 0, 0
	if endTime > 0 and cooldownLength > 1.5 then
		realCooldown = endTime - now
	end

	local btype, spellId = GetActionInfo(slot)
	if( btype == 'macro' ) then
		local name, rank, spellId2 = GetMacroSpell( spellId )
		if spellId2 then
			btype = 'spell'
			spellId = spellId2
		end
		--[[
		if( name ) then
			if rank then
				name = name.."("..rank..")"
			end
			btype = 'spell';
			spellId = name;
		end
		--]]
	end
	
	if( btype == 'spell' ) then
		local spellName, _, _, spellCost, _, powerType, castingTime = GetSpellInfo(spellId)

		if auras[spellName] then
			auraDuration = auras[spellName] - now
		elseif SharedAuras[spellId] and auras[SharedAuras[spellId]] then
			auraDuration = auras[SharedAuras[spellId]] - now
		end
		
		if powerType == 5 and not IsUsableAction(slot) then -- runes
			realCooldown = GetRuneCooldownBySpell(spellId)
		end
		
		local totemTime = GetTotemCooldown(spellName)
		if totemTime > 0 then
			auraDuration = totemTime - now
		end
		
		if UnitPowerType("player") == powerType then -- because GetPowerRegen only works for the active energy type
			local currentPower = UnitPower("player", powerType)
			if spellCost > currentPower then
				local passiveRegen, activeRegen = GetPowerRegen()
				local regenRate = 0
				if UnitAffectingCombat("player") then
					regenRate = activeRegen
				else
					regenRate = passiveRegen
				end
				local powerDifference = spellCost - currentPower
				if regenRate >= 1 then
					energyCooldown = powerDifference/regenRate
				end
			end
		end
	elseif btype == 'item' then
		--print(spellId)
	end
	
	if realCooldown > energyCooldown and realCooldown > 0 then
		return realCooldown, "ff0000"
	elseif energyCooldown > 0 then
		return energyCooldown, "ffff00"
	else
		return auraDuration, "00ff00"
	end
end


function updateAuras()
	wipe(auras)
	if UnitExists("target") and not (not UnitIsPlayer("target") and not UnitCanAttack("player", "target")) then
		unit = "target"
	else
		unit = "player"
	end
	if UnitIsFriend("player", unit) then
		for i = 1,40 do
			--local name, _, _, _, _, _, expires = UnitBuff(unit, i, "player")
			local name, rank, icon, count, dispelType, duration, expires, caster, isStealable, shouldConsolidate, spellID, canApplyAura, isBossDebuff, value1, value2, value3 = UnitBuff(unit, i)
			if not name then break end
			if caster == "player" and expires > 0 then
				auras[name] = expires
			elseif SharedAuras[spellID] and expires > 0 then
				auras[SharedAuras[spellID]] = expires
			end
		end
	else
		for i = 1,40 do
			--local name, _, _, _, _, _, expires = UnitDebuff(unit, i, "player")
			local name, rank, icon, count, dispelType, duration, expires, caster, isStealable, shouldConsolidate, spellID, canApplyAura, isBossDebuff, value1, value2, value3 = UnitDebuff(unit, i)
			if not name then break end
			if caster == "player" and expires > 0 then
				auras[name] = expires
			elseif SharedAuras[spellID] and expires > 0 then
				auras[SharedAuras[spellID]] = expires
			end
		end
		for i = 1,40 do
			--local name, _, _, _, _, _, expires = UnitBuff("player", i, "player")
			local name, rank, icon, count, dispelType, duration, expires, caster, isStealable, shouldConsolidate, spellID, canApplyAura, isBossDebuff, value1, value2, value3 = UnitBuff("player", i)
			if not name then break end
			if caster == "player" and expires > 0 then
				auras[name] = expires
			elseif SharedAuras[spellID] and expires > 0 then
				auras[SharedAuras[spellID]] = expires
			end
		end
	end
end

local function updateButtons()
	local now = GetTime()
	for _, overlay in ipairs(overlays) do
		--local slot = ActionButton_GetPagedID(overlay.button)
		local slot = overlay.button:GetAttribute("action") or ActionButton_GetPagedID(overlay.button)
		if slot then
			local cooldown, color = GetSlotCooldown(slot)
			if cooldown > 0 then
				local x,t = formatTime(cooldown)
				overlay.text:SetFormattedText("|cff"..color..x.."|r", t)
				if IsUsableAction(slot) and color == "00ff00" then
					overlay.frame.texture:SetVertexColor(0, 1, 0, 1)
				else
					overlay.frame.texture:SetVertexColor(1, 0, 0, 1)
				end
				if not overlay.frame:IsVisible() then
					overlay.frame:Show()
				end
			else
				if overlay.frame:IsVisible() then
					overlay.frame:Hide()
				end
				overlay.text:SetText()
			end
		else
			local cooldown = overlay.frame.start + overlay.frame.duration - now
			--print(overlay.button:GetName(), overlay.frame.expires)
			if cooldown > 0 and overlay.frame.duration > 1.5 then
				local w = overlay.frame:GetWidth()
				if w > 0 then
					overlay.text:ClearAllPoints()
					overlay.frame:Hide()
					overlay.frame.texture:Hide()
					overlay.text:SetText()
					if w < 26 then
						if cooldown < 60 then
							overlay.text:SetPoint("CENTER", overlay.button, "TOPRIGHT")
							overlay.text:SetFont("Fonts\\FRIZQT__.TTF", w*.7, "OUTLINE")
							overlay.text:SetFormattedText("|cffffff00%d|r", cooldown)
							overlay.frame:Show()
						end
					else
						local x,t = formatTime(cooldown)
						overlay.text:SetPoint("CENTER")
						overlay.text:SetFont("Fonts\\FRIZQT__.TTF", w*.5, "OUTLINE")
						overlay.text:SetFormattedText("|cffffff00"..x.."|r", t)
						overlay.frame:Show()
					end
				end
			else
				if overlay.frame:IsVisible() then
					overlay.frame:Hide()
				end
				overlay.text:SetText()
			end
		end
	end
end

function f:ACTIONBAR_SLOT_CHANGED()
	updateButtons()
end

function f:ACTIONBAR_UPDATE_COOLDOWN()
	updateButtons()
end

function f:UNIT_AURA()
	updateAuras()
end

function f:PLAYER_TARGET_CHANGED()
	updateAuras()
end

local timeSinceLastUpdate = 0
f:SetScript("OnUpdate", function(self, elapsed)
	timeSinceLastUpdate = timeSinceLastUpdate + elapsed
	if( timeSinceLastUpdate > 0.1 ) then
		updateButtons()
		timeSinceLastUpdate = 0
	end
end)

f:SetScript("OnEvent", function(self, event, ...) if self[event] then return self[event](self, ...) end end)



local ActionButtons = {}
local function GetActionButtons(...)
	for i = 1, select('#',...) do
		local frame = select(i, ...)
		if frame:GetNumChildren() > 0 then
			GetActionButtons(frame:GetChildren())
		end
		if frame:GetAttribute("type") == "action" then
			tinsert(ActionButtons, frame)
		end
	end
end

local function makeOverlays()
	for i, button in ipairs(ActionButtons) do
		if not button then return end
		if not button.CrackCooldownOverlay then
			local frame = CreateFrame("frame", nil, button)
			--frame:Hide()
			frame:SetAllPoints(button)
			frame:SetFrameLevel(button:GetFrameLevel() + 3)
			
			local text = frame:CreateFontString(nil, "OVERLAY")
			text:SetPoint("CENTER")
			text:SetFont("Fonts\\FRIZQT__.TTF", 18, "OUTLINE")
			--text:SetFont("Fonts\\ARIALN.TTF", 14, "OUTLINE")
			
			local action = button:GetAttribute("action") or ActionButton_GetPagedID(button) or "?"
			text:SetText(action)
			text:SetShadowOffset(1,-1)
			
			tinsert(overlays, {
				button = button,
				frame = frame,
				text = text,
			})
			
			-- hilight texture to test visibility of frame --
			local t = frame:CreateTexture(nil,"BACKGROUND");
			t:SetTexture("Interface\\Buttons\\CheckButtonHilight");
			t:SetAllPoints(frame);
			t:SetBlendMode("add");
			t:SetVertexColor(0, 0.25, 1, 1);
			frame.texture = t;
			-- end hilight texture --
			button.CrackCooldownOverlay = frame
		end
	end
end

local function ActionHook(self, attribute, slot)
	if attribute ~= "action" or self.CrackCooldownOverlay then return end
	if HasAction(slot) then
		--print(self:GetName(), GetActionInfo(slot))
		tinsert(ActionButtons, self)
		makeOverlays()
	end
end
hooksecurefunc(getmetatable(ActionButton1).__index, 'SetAttribute', ActionHook)



local CooldownFrames = {}
local function GetCooldownFrames(...)
	for i = 1, select('#',...) do
		local frame = select(i, ...)
		if frame:GetNumChildren() > 0 then
			GetCooldownFrames(frame:GetChildren())
		end
		if getmetatable(frame).__index.SetCooldown then
			local parent = frame:GetParent()
			if not parent.coolio then
				parent.coolio = true -- make the texture hereeeeeeee
				tinsert(CooldownFrames, frame)
				local t = parent:CreateTexture(nil,"OVERLAY");
				t:SetTexture("Interface\\Buttons\\CheckButtonHilight");
				t:SetAllPoints(parent);
				t:SetBlendMode("add");
				t:SetVertexColor(0, 0.25, 1, 1);
				local text = parent:CreateFontString(nil, "OVERLAY")
				text:SetPoint("CENTER")
				text:SetFont("Fonts\\FRIZQT__.TTF", 18, "OUTLINE")
				--[[
				local start, duration, enable = GetContainerItemCooldown(parent:GetParent():GetID(), parent:GetID())
				if (start > 0 and duration > 0 and enable > 0) then
					text:SetText(start+duration-GetTime())
				end
				--]]
			else
				
			end
		end
	end
end

function PrintCooldownFrames()
	GetCooldownFrames(UIParent:GetChildren())
	print(#CooldownFrames)
	for i,frame in ipairs(CooldownFrames) do
		local parent = frame:GetParent()
		--if not parent.coolio then
		local parentname = parent:GetName()
		--if parentname then
		--	print(parentname)
		--end

		if parentname:find('Container') then
			print(parentname)
		end
		--end
	end
end

--/script x='';for k,_ in pairs(getmetatable(ActionButton1.cooldown).__index) do x=x..', '..k end;print(x)
hooksecurefunc(getmetatable(ActionButton1.cooldown).__index, "SetCooldown",
function(cooldown, start, duration, enable)
	local button = cooldown:GetParent()
	if not button.CrackCooldownOverlay then
		local frame = CreateFrame("frame", nil, cooldown)
		--frame:Hide()
		frame:SetAllPoints(button)
		frame:SetFrameLevel(button:GetFrameLevel() + 3)
		
		local text = frame:CreateFontString(nil, "OVERLAY")
		text:SetPoint("CENTER")
		text:SetFont("Fonts\\FRIZQT__.TTF", 18, "OUTLINE")
		--text:SetFont("Fonts\\ARIALN.TTF", 14, "OUTLINE")
		
		--text:SetText("x")
		text:SetShadowOffset(1,-1)
		
		tinsert(overlays, {
			button = button,
			frame = frame,
			text = text,
			start = 0,
			duration = 0,
		})
		
		-- hilight texture to test visibility of frame --
		local t = frame:CreateTexture(nil,"BACKGROUND");
		t:SetTexture("Interface\\Buttons\\CheckButtonHilight");
		t:SetAllPoints(frame);
		t:SetBlendMode("add");
		t:SetVertexColor(0, 0.25, 1, 1);
		frame.texture = t;
		-- end hilight texture --
		button.CrackCooldownOverlay = frame
	end
	if start > 0 and duration > 0 then
		button.CrackCooldownOverlay.start = start
		button.CrackCooldownOverlay.duration = duration
	else
		button.CrackCooldownOverlay.start = 0
		button.CrackCooldownOverlay.duration = 0
	end
	--print("SetCooldown",cooldown:GetParent():GetName(),start+duration-GetTime())
end)
--[[
hooksecurefunc("CooldownFrame_SetTimer", function(cooldown, start, duration, enable)
	if start > 0 then
		print(cooldown:GetName(), start, duration, enable)
	end
end)
--]]
--hooksecurefunc(getmetatable(PetActionButton1).__index, "OnEnter", function(...) print(...) end)
--PetActionButton1:SetScript("OnEnter", function(self,...) print("sup", ...) end)
--hooksecurefunc(PetActionButtonDown, function(...) print("x",...) end)
--hooksecurefunc(PetActionButton_OnClick, function(self, ...) print("x",...) end)
f:RegisterEvent("PLAYER_LOGIN")
function f:PLAYER_LOGIN()
	GetActionButtons(UIParent:GetChildren())
	f.TimeSinceLastUpdate = 0
	f:RegisterEvent("ACTIONBAR_SLOT_CHANGED")
	f:RegisterEvent("ACTIONBAR_PAGE_CHANGED")
	f:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN")
	f:RegisterEvent("UNIT_AURA")
	f:RegisterEvent("PLAYER_TARGET_CHANGED")
	makeOverlays()
end



--local sgvi = SpellGetVisibilityInfo
--[[
hooksecurefunc("SpellGetVisibilityInfo", function(spellId, arg, ...)
	print(spellId, arg, ...)
	print(sgvi(spellId, arg, ...))
end)
]]

--SpellGetVisibilityInfo = function(spellId, arg, ...)
	--print(GetSpellLink(spellId))
	--return true, true, true
--end